From cad2faec996ca9f3a44655b10d99f6e4f09c4bf4 Mon Sep 17 00:00:00 2001
From: Bernd Zeimetz <bernd@bzed.de>
Date: Thu, 8 Oct 2015 12:45:55 -0700
Subject: =?UTF-8?q?fix=20compilation=20for=20python2.5.=20Seems=20to=20fai?=
 =?UTF-8?q?l=20on=2064bit=20arches=20only.=0APatch-Name:=2050=5F64bit-py25?=
 =?UTF-8?q?-compile-fix?=

---
 include/unpack.hh     |  4 ++++
 include/unpack_ptr.hh | 25 ++++++++++++++++++++-----
 src/glReadPixels.cc   | 12 ++++++++++++
 3 files changed, 36 insertions(+), 5 deletions(-)

diff --git a/include/unpack.hh b/include/unpack.hh
index 0dbd7e3..3a825a8 100644
--- a/include/unpack.hh
+++ b/include/unpack.hh
@@ -68,7 +68,11 @@ inline GLfloat* unpack<GLfloat*>(PyObject* object)
 {
   // return (GLfloat)PyFloat_AsDouble(object);
   void *buffer;
+#if PY_VERSION_HEX >= 0x020500F0 /* Python >= 2.5 */
+  ssize_t len;
+#else
   int len;
+#endif
   if ( PyObject_AsWriteBuffer(object, &buffer, &len) < 0 ) {
     throw pyglew_exception("In 'unpack<GLfloat*>' unable to access write buffer.");
   } 
diff --git a/include/unpack_ptr.hh b/include/unpack_ptr.hh
index 3a370d4..e11d77a 100644
--- a/include/unpack_ptr.hh
+++ b/include/unpack_ptr.hh
@@ -54,8 +54,13 @@ inline pointer_wrapper<const GLfloat*> unpack_ptr(PyObject* object) throw (pygle
 
   if ( PyObject_CheckReadBuffer(object) ) {
     float* ptr = 0;
-    int length = 0;
-    
+
+#if PY_VERSION_HEX >= 0x020500F0 /* Python >= 2.5 */
+  ssize_t length = 0;
+#else
+   int length = 0;
+#endif
+
     if ( PyObject_AsReadBuffer(object, const_cast<const void**>((void**)&ptr), &length) < 0 ) {
       throw pyglew_exception("Internal error when trying to convert %s to 'const GLfloat*': PyObject_AsReadBuffer failed!", 
                              PyString_AsString(PyObject_Str(PyObject_Type(object))));
@@ -84,8 +89,13 @@ inline pointer_wrapper<const GLuint*> unpack_ptr(PyObject* object) throw (pyglew
 
   if ( PyObject_CheckReadBuffer(object) ) {
     GLuint* ptr = 0;
-    int length = 0;
-    
+
+#if PY_VERSION_HEX >= 0x020500F0 /* Python >= 2.5 */
+  ssize_t length = 0;
+#else
+   int length = 0;
+#endif
+   
     if ( PyObject_AsReadBuffer(object, const_cast<const void**>((void**)&ptr), &length) < 0 ) {
       throw pyglew_exception("Internal error when trying to convert %s to 'const GLfloat*': PyObject_AsReadBuffer failed!", 
                              PyString_AsString(PyObject_Str(PyObject_Type(object))));
@@ -109,7 +119,12 @@ inline pointer_wrapper<const GLvoid*> unpack_ptr(PyObject* object)
 
   if ( PyObject_CheckReadBuffer(object) ) {
     float* ptr = 0;
-    int length = 0;
+
+#if PY_VERSION_HEX >= 0x020500F0 /* Python >= 2.5 */
+  ssize_t length = 0;
+#else
+   int length = 0;
+#endif
     
     if ( PyObject_AsReadBuffer(object, const_cast<const void**>((void**)&ptr), &length) < 0 ) {
       throw pyglew_exception("Internal error when trying to convert %s to 'const GLfloat*': PyObject_AsReadBuffer failed!", 
diff --git a/src/glReadPixels.cc b/src/glReadPixels.cc
index d2d4a4f..b4f6250 100644
--- a/src/glReadPixels.cc
+++ b/src/glReadPixels.cc
@@ -39,7 +39,12 @@ PyObject* __glReadPixels(PyObject*, PyObject* args)
     PyObject* buf = PyBuffer_New(size);
     
     GLvoid* ptr;
+
+#if PY_VERSION_HEX >= 0x020500F0 /* Python >= 2.5 */
+    ssize_t len;
+#else
     int len;
+#endif
     
     if ( PyObject_AsWriteBuffer(buf, &ptr, &len) < 0 || len != size ) { 
       PyErr_SetString(PyExc_RuntimeError, "Internal error in glReadPixels. Could not convert last arg to write buffer");
@@ -74,7 +79,14 @@ PyObject* __glReadPixels(PyObject*, PyObject* args)
 
     } else {
       void* ptr;
+
+#if PY_VERSION_HEX >= 0x020500F0 /* Python >= 2.5 */
+      ssize_t len;
+#else
       int len;
+#endif
+
+
       if ( PyObject_AsWriteBuffer(ptrobj, &ptr, &len) < 0) {
         PyErr_SetString(PyExc_RuntimeError, "Internal error in glReadPixels. Could not convert last arg to write buffer");
         return NULL;
